Desktop/devcamp-portfolio/config/routes.rb
Rails.application.routes.draw do
  devise_for :users, path: '', path_names: { sign_in: 'login', sign_out: 'logout', sign_up: 'register' }
  resources :portfolios, except: [:show]
  get 'angular-items', to: 'portfolios#angular'
  get 'portfolio/:id', to: 'portfolios#show', as: 'portfolio_show'

  get 'about-me', to: 'pages#about'
  get 'contact', to: 'pages#contact'

  resources :blogs do
    member do
      get :toggle_status
    end
  end
  
  root to: 'pages#home'
end

Desktop/devcamp-portfolio/app/models/blog.rb
class Blog < ApplicationRecord
  enum status: { draft: 0, published: 1 }
  extend FriendlyId
  friendly_id :title, use: :slugged

  validates_presence_of :title, :body

  belongs_to :topic

  def self.special_blogs
    all
  end

  def self.featured_blogs
    limit(2)
  end
end

Desktop/devcamp-portfolio/app/controllers/blogs_controller.rb
class BlogsController < ApplicationController
  before_action :set_blog, only: [:show, :edit, :update, :destroy, :toggle_status]
  layout "blog"
  access all: [:show, :index], user: {except: [:destroy, :new, :create, :update, :edit]}, site_admin: :all

  def index
    @blogs = Blog.special_blogs
    @page_title = "My Portfolio Blog"
  end

  def show
    @page_title = @blog.title
    @seo_keywords = @blog.body
  end

  def new
    @blog = Blog.new
  end

  def edit
  end

  def create
    @blog = Blog.new(blog_params)

    respond_to do |format|
      if @blog.save
        format.html { redirect_to @blog, notice: 'Your post is now live.' }
      else
        format.html { render :new }
      end
    end
  end
 
  def update
    respond_to do |format|
      if @blog.update(blog_params)
        format.html { redirect_to @blog, notice: 'Blog was successfully updated.' }
      else
        format.html { render :edit }
      end
    end
  end

  def destroy
    @blog.destroy
    respond_to do |format|
      format.html { redirect_to blogs_url, notice: 'Post was removed.' }
      format.json { head :no_content }
    end
  end

  def toggle_status
    if @blog.draft?
      @blog.published!
    elsif @blog.published?
      @blog.draft!
    end

    redirect_to blogs_url, notice: 'Post status has been updated.'
  end

  private
    def set_blog
      @blog = Blog.friendly.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def blog_params
      params.require(:blog).permit(:title, :body)
    end
end

Desktop/devcamp-portfolio/app/helpers/blogs_helper.rb
module BlogsHelper
end

Desktop/devcamp-portfolio/app/views/blogs/_blog.html.erb
<tr>
  <td><%= blog.title.upcase %></td>
  <td>Published <%= distance_of_time_in_words(blog.created_at, Time.now) %> ago</td>
  <td><%= blog.body %></td>
  <td><%= link_to blog.status, toggle_status_blog_path(blog) %></td>
  <td><%= link_to 'Show', blog %></td>
  <td><%= link_to 'Edit', edit_blog_path(blog) if logged_in?(:site_admin) %></td>
  <td><%= link_to 'Delete Post', blog, method: :delete, data: { confirm: 'Are you sure?' } if logged_in?(:site_admin) %></td>
</tr>

Desktop/devcamp-portfolio/app/views/blogs/_form.html.erb
<%= form_for(blog) do |f| %>
  <% if blog.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(blog.errors.count, "error") %> prohibited this blog from being saved:</h2>

      <ul>
      <% blog.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :title %>
    <%= f.text_field :title %>
  </div>

  <div class="field">
    <%= f.label :body %>
    <%= f.text_area :body %>
  </div>

  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

Desktop/devcamp-portfolio/app/views/blogs/edit.html.erb
<h1>Editing Blog</h1>

<%= render 'form', blog: @blog %>

<%= link_to 'Show', @blog %> |
<%= link_to 'Back', blogs_path %>

Desktop/devcamp-portfolio/app/views/blogs/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Blogs</h1>

<table>
  <thead>
    <tr>
      <th>Blog Title</th>
      <th>Date</th>
      <th>Body</th>
      <th colspan="4"></th>
    </tr>
  </thead>

  <tbody>
    <%= render @blogs %>
  </tbody>
</table>

<br>

<%= link_to 'New Blog', new_blog_path if logged_in?(:site_admin) %>

Desktop/devcamp-portfolio/app/views/blogs/new.html.erb
<h1>New Blog</h1>

<%= render 'form', blog: @blog %>

<%= link_to 'Back', blogs_path %>

Desktop/devcamp-portfolio/app/views/blogs/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Title:</strong>
  <%= @blog.title %>
</p>

<p>
  <strong>Body:</strong>
  <%= @blog.body %>
</p>

<%= link_to 'Edit', edit_blog_path(@blog) if logged_in?(:site_admin) %> |
<%= link_to 'Back', blogs_path %>